'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AdharaFormView = function (_AdharaView) {
    _inherits(AdharaFormView, _AdharaView);

    function AdharaFormView() {
        _classCallCheck(this, AdharaFormView);

        return _possibleConstructorReturn(this, (AdharaFormView.__proto__ || Object.getPrototypeOf(AdharaFormView)).apply(this, arguments));
    }

    _createClass(AdharaFormView, [{
        key: 'onSuccess',
        value: function onSuccess(data) {
            //Override this to handle success event...
        }
    }, {
        key: 'onError',
        value: function onError(error) {
            //Override this to handle error event...
        }
    }, {
        key: '_onSuccessProcessor',
        value: function _onSuccessProcessor(context, data) {
            this.onSuccess(data, context.form);
        }
    }, {
        key: '_onErrorProcessor',
        value: function _onErrorProcessor(context, error) {
            this.onError(error);
        }
    }, {
        key: 'getFormElement',
        value: function getFormElement() {
            return this.getParentContainerElement().querySelector("form");
        }
    }, {
        key: '_handleForm',
        value: function _handleForm(form) {
            var _this2 = this;

            if (form.submitting) {
                return;
            } else {
                form.submitting = true;
            }
            var hasFiles = !!form.querySelector('input[type="file"]');
            var apiData = void 0;
            if (hasFiles) {
                apiData = new FormData(form);
            } else {
                var formData = jQuery(form).serializeArray();
                apiData = {};
                jQuery.each(formData, function (i, fieldData) {
                    apiData[fieldData.name] = fieldData.value;
                });
            }
            var format_fn = form.getAttribute('format-data');
            if (format_fn) {
                apiData = call_fn(format_fn, apiData);
            }
            if (apiData === false) {
                return;
            }
            return Controller.control(form.getAttribute('api-method') || "post", {
                data_config: { url: form.action.split(window.location.host)[1] },
                form: form,
                processor: {
                    success: function success(context, data) {
                        _this2._onSuccessProcessor(context, data);
                        form.submitting = false;
                    },
                    error: function error(context, _error) {
                        _this2._onErrorProcessor(context, _error);
                        form.submitting = false;
                    }
                }
            }, apiData);
            /*RestAPI[form.getAttribute('api-method')]({
                url: form.action.split(window.location.host)[1],
                data: apiData,
                successMessage: form.getAttribute('success-message'),
                handleError: form.getAttribute('handle-error')!=="false",
                success: function(data){
                    if(form.getAttribute('form-clear')==="true") {
                        form.reset();
                    }
                    jQuery(form).trigger('success', data);
                },
                failure: function(message){
                    jQuery(form).trigger('failure', message);
                }
            });*/
        }
    }, {
        key: '_format',
        value: function _format(container) {
            var _this3 = this;

            container.querySelector("form").addEventListener("submit", function (event) {
                event.preventDefault();
                _this3._handleForm(event.target);
            });
            jQuery(container).on('success', 'form', function (response) {
                _this3.onSuccess();
            });
            jQuery(container).on('failure', 'form', function (e, message) {
                _this3.onError();
            });
            _get(AdharaFormView.prototype.__proto__ || Object.getPrototypeOf(AdharaFormView.prototype), '_format', this).call(this, container);
        }
    }]);

    return AdharaFormView;
}(AdharaView);
//# sourceMappingURL=FormView.js.map